;*********PERSONAL NOTE TO ROLAND*********
; Thank you for helping me through this debugging process.
;The only areas of concern deal with these three data bases:
;Sales, POS, and Trans.
;What I am trying to do is :
;While in Coedit mode in the Trans master form, I want to
;assign a transaction number[TRANS NO] that looks at 
;Sales.db, field [TRANS NO], takes the highest transaction
;number in that field, increment it by one and place that
;value in the [TRANS NO] field of Trans.db (which is the master
;table). This newly assigned transaction number must be the same
;for each record that is entered during the Coedit session.
;PLEASE LET ME KNOW IF WHAT I AM TRYING TO DO IS EVEN POSSIBLE
;THROUGH PARADOX!!, Thank you, Carol Ashley,loyal Paradox user.
;(714) 750-8746
;NOTE: The code that is currently in this script was done under
;direction of one of your Tech. support people - go figure.


; Script      : GACSMAIN.SC
; Description : Begins The Great American Craft Show Applications

RELEASE VARS ALL
RELEASE PROCS ALL

ALTSPACE {Desktop} {Empty}
ECHO NORMAL      ; display the empty desktop
ECHO OFF         ; then turn echo off to freeze the screen displaY
ECHO OFF
PROC CHIME()
PRIVATE  G,Middle_C,High_G,
         Quarter_Note,Half_Note
   G         = Int(440*Pow(2,-2/12))
   Middle_C  = Int(440*Pow(2,3/12))
   High_G    = Int(440*Pow(2,10/12))
   Quarter_Note = 337
   Half_Note    = 675
   
   Sound Middle_C Quarter_Note
   Sound G        Quarter_Note
   Sound High_G   Half_Note
ENDPROC

SHOWDIALOG "THE GREAT AMERICAN CRAFT SHOW" @ 2, 11 HEIGHT 20 WIDTH 50

   @ 2, 10 ?? "**** G O O D    M O R N I N G ! ! ****"
   @ 4, 10 ?? "Please Verify Today's Date"
    
   @ 8, 20 ?? FORMAT("D1",TODAY()) 
   PAINTCANVAS BORDER FILL CHR(219) 6,18,10,30
   PAINTCANVAS ATTRIBUTE 15 + 16 7,19,9,29

   PUSHBUTTON @ 12,6 WIDTH 14
      "~O~K"
      OK
      DEFAULT
      VALUE "Accept"
      TAG "Yes"
      TO ButtonValue

   PUSHBUTTON @12,29 WIDTH 14
      "~I~NCORRECT"
      CANCEL
      VALUE "Say No"
      TAG "No"
      TO ButtonValue
ENDDIALOG



PROC Main()
   PRIVATE MenuItemSelected,
           ExitApplication   
   
   ShowSplashScreen()
   
   DisplayMainMenu()

   ExitApplication = False

   WHILE (ExitApplication <> True)

   GreyMainMenuItems()

      ; Wait for the user to select an item from the main menu. The menu
      ; was displayed by DisplayMainMenu().

      GETMENUSELECTION TO MenuItemSelected

      SWITCH
         CASE (MenuItemSelected = "Exit/Yes") : ; user wants to exit
            ExitApplication = True

         CASE (MenuItemSelected = "Exit/No") :  ; user has decided not to exit
            ExitApplication = False

         CASE (MenuItemSelected = "AltSpace/About") : ; user wants info about
                                                      ; program
            DisplayAboutBox()

         CASE (MenuItemSelected = "NewSale") :        ; user wants to modify
            EnterNewSale()                            ; the POS table

         CASE (MenuItemSelected = "ViewMem") :        ; user wants to view
            PLAY "Mem1"                               ; the Members table

         CASE (MenuItemSelected = "NewMem") :         ; user wants to enter
            PLAY "Mem2"                               ; new Members in the
                                                      ; Members table
                                                      
         CASE (MenuItemSelected = "Viewinv") :        ; user wants to view
            PLAY "Inv1"                               ; the Inventory table

         CASE (MenuItemSelected = "Newinv") :         ; user wants to enter
            PLAY "Inv2"                               ; new Items in the
                                                      ; Items table


         CASE (MenuItemSelected = "Report/All") :     ; user wants to create
            PrintAllRecords()                         ; a report on ALL
                                                      ; customers

         CASE (MenuItemSelected = "Report/West Coast") : ; user wants to
            PrintWestCoastRecords()                      ; create a report
                                                         ; on West Coast
                                                         ; customers only.

      ENDSWITCH

   ENDWHILE

   CLEARPULLDOWN

ENDPROC

PROC DisplayMainMenu()

   ; Display the main pulldown menu.
   SHOWPULLDOWN
      ""      : "Program Information."               : "AltSpace"
         SUBMENU
            "About" : "About this application."       : "AltSpace/About"
         ENDSUBMENU,
      "Pos"    : "Go to Sales Menu."                  : "POS"
         SUBMENU
            "New Sale" : "Modify POS table."          : "NewSale",
            "Close"  : "Close Invoice table."         : "Table/Close"
         ENDSUBMENU,
      "Members"    : "Go to Member Menu."             : "Members"
         SUBMENU
            "View Members" : "Go to Member.db"        : "Viewmem",
            "Enter New Members": "Enter New."         : "Newmem"
         ENDSUBMENU,         
      "Inventory"    : "Go to Inventory Menu."        : "Items"
         SUBMENU
            "View Inventory" : "Go to Items.db."      : "Viewinv",
            "Enter Inventory": "Enter new Inv Items." : "Newinv"
         ENDSUBMENU,                           
      "Report" : "Report on Customer Table."     : "Report"
         SUBMENU
            "All"        : "Print report of all customers."  :
                           "Report/All",
            "West Coast" : "Print report of only West Coast customers" :
                           "Report/West Coast"
         ENDSUBMENU,
      "Exit"   : "Exit this application."        : "Exit"
         SUBMENU
            "No"  : "Do not exit application." : "Exit/No",
            "Yes" : "Exit this application."   : "Exit/Yes"
         ENDSUBMENU
   ENDMENU

ENDPROC



; --------------------------------------------------------------------------
; Procedure   : GreyMainMenuItems()
; Description : This procedure greys out (dims) menu items which are not
;               applicable from the Main Menu. These items are no longer
;               selectable from the menu.
; Called By   : Main()
; --------------------------------------------------------------------------

PROC GreyMainMenuItems()

   MENUDISABLE "Table/Close"

;  Enable main menu selections
   MENUENABLE "NewSale"
   MENUENABLE "Viewmem"
   MENUENABLE "Newmem"
   MENUENABLE "Viewinv"
   MENUENABLE "Newinv"
   MENUENABLE "Exit/No"
   MENUENABLE "Exit/Yes"

ENDPROC

; --------------------------------------------------------------------------
; Procedure   : DisplayAboutBox()
; Description :
;    Creates a simple dialog box displaying information about the
;    application.  It uses the SHOWDIALOG command to create the box
;    with  a single button which, when pressed, clears the box.
; Called by   : Main(),
; --------------------------------------------------------------------------

PROC DisplayAboutBox()

   ; Create a dialog box with the following dimensions...
   SHOWDIALOG "THE GREAT AMERICAN CRAFT SHOW"
      @ 5, 10
      HEIGHT 12
      WIDTH 60

      @ 1, 0 ?? FORMAT("W58,AC", "Sales Applications")
      @ 3, 0 ?? FORMAT("W58,AC", "Personally programed by.....")
      @ 5, 0 ?? FORMAT("W58,AC", "Yours truly, Carolyn Ashley")


      ; The following creates the single OK button at the noted
      ; coordinates. The "~" character assigns Alt-O as the button hot key.
      ; Because this is the only push button in the dialog box there
      ; is no need to analyze the results.
      PUSHBUTTON @ 8, 23
         WIDTH 12
         "~O~K"
         OK
         VALUE "OKButtonPressed"
         TAG "OKButton"
      TO OKButton

   ENDDIALOG

ENDPROC

PROC GetTransNo()
   IF ISBLANK([TRANS NO])
      THEN D=[TRANS NO]
      WINDOW SELECT SalesWindow
      C=("Sales,"[TRANS NO]) 
      C= C + 1
      D=C
      POSTRECORD NOPOST LEAVELOCKED
      LOCKRECORD
      UNLOCKRECORD
      WINDOW SELECT TransWindow
   ENDIF
ENDPROC







     
; --------------------------------------------------------------------------
; Procedure  : EnterNewSale()
; Description:
;    Wait on table. Allow the user to work with the
;              table until s/he presses Formkey, Do_It!, Del,
;              Ctrl-T, or F10. F10 activates the SHOWPULLDOWN menu and
;              temporarily suspends the WAIT until the menu interaction
;              is complete.
; Called By  : Main
; --------------------------------------------------------------------------

PROC EnterNewSale()

   ; Place the Trans table in CoEdit mode, pick the "F" form, and
   ; set the window conditions.
           
     COEDIT "Trans"  
     PICKFORM "F"
     GetTransNo()
 
      
   ;  Move the table to a location where the user will not accidentally
   ;  display it.
   WINDOW MOVE GETWINDOW() TO -100, -100


   ; Get the handle of the form window.
   WINDOW HANDLE CURRENT TO PosWindow

   ; Specify attributes of the form window in a dynamic array.
   DYNARRAY WindowAttributes[]
   WindowAttributes["HEIGHT"]    = 21
   WindowAttributes["ORIGINROW"] = 1
   WindowAttributes["ORIGINCOL"] = 0
   WindowAttributes["CANMOVE"]   = True
   WindowAttributes["CANRESIZE"] = True
   WindowAttributes["CANCLOSE"]  = False

   ; Now apply these attributes to the form window
   WINDOW SETATTRIBUTES PosWindow FROM WindowAttributes

   ; Enable/Disable menu selections.
   GreyModifyMenuItems()

   ; Wait on the workspace table. The prompt line is placed at the
   ; bottom of the screen, telling the users what shortcut keys are
   ; available.
   ; When an event is "trapped" by the wait, the procedure
   ; "ProcessWaitEvents" is called. This procedure acts as a handler,
   ; deciding what to do with the particular event. In turn
   ; a value of 0, 1, or 2 is returned to the wait.
   ;     0 - processes the event and proceeds to the next event in the
   ;         trigger cycle.
   ;     1 - does NOT process the current event and breaks out of the
   ;         trigger cycle, but does NOT break out of the wait.
   ;     2 - does NOT process the current event and breaks out of the
   ;         trigger cycle AND the wait.

   PROMPT " [F2] Close  [F10] Menu  [Ctrl-T] End of Sale " +
          " [Ctrl-L] Update Customer"                           ; set PROMPT


   WAIT WORKSPACE
      PROC "ProcessWaitEvents" ; call the wait procedure when any of the
                               ; specified events occurs. The procedure must
                               ; return a 2 to break out of the wait.

         ; Trap the following keypresses. Note that we use numeric keycodes
         ; that are explained in the comment following the KEY statement.
         KEY -83, -60, 15, 20, -24, -18, -31, 26, -44, -97
         ; Del, Do_It!, Ctrl-O, Ctrl-T, Alt-O, Alt-E, Alt-S, Ctrl-Z, Alt-Z, Ctrl-F4

         ; Trap the following message event. If the user interacts with a
         ; SHOWPULLDOWN menu and either selects an item or presses a MenuKey,
         ; a MENUSELECT message will occur and the WAIT procedure will be
         ; called.
      
         MESSAGE "MENUSELECT"
   ENDWAIT
      

   PROMPT ""   ; clear the PROMPT after leaving the WAIT
   DO_IT!      ; close the edit session
   CLEARALL    ; clear the table from the workspace.
ENDPROC
   ECHO NORMAL
   ECHO OFF

; --------------------------------------------------------------------------
; Procedure   : GreyModifyMenuItems()
; Description : This procedure greys out (dims) items on the SHOWPULLDOWN
;               menu which are not available while the user is coediting
;               the multi-table form. Greyed items cannot be selected
;               from the menu.
; Called By   : EnterNewSale()
; --------------------------------------------------------------------------

PROC GreyModifyMenuItems()

   ; Disable the following menu items.
   MENUDISABLE "Viewmem"
   MENUDISABLE "Newmem"
   MENUDISABLE "Viewinv"
   MENUDISABLE "Newinv"  
   MENUDISABLE "Report/All"
   MENUDISABLE "Report/West Coast"
   MENUDISABLE "Exit/No"
   MENUDISABLE "Exit/Yes"
   ; Enable the following menu item.
   MENUENABLE "Table/Close"

ENDPROC



; --------------------------------------------------------------------------
; Procedure   : ProcessWaitEvents()
; Description :
;    Proc is called when an event is triggered from the modify table wait.
;         The procedure evaluates the kind of message and does the appropriate
;         processing, then returns a value of 0, 1, or 2 to the wait (See
;         LetUserModifyTable proc for details on the return values).

; Called By   : EnterNewSale()
; --------------------------------------------------------------------------

PROC ProcessWaitEvents(TriggerType, EventInfo, CycleNumber)

;  The TriggerType argument is assigned a value based on the type of event
;  or trigger that the procedure was called for. The dynamic array
;  EventInfo contains information about the event which occurred during
;  the wait. If the EventInfo element "Type" is "KEY", then we examine the
;  element "KEYCODE" to determine the numeric keycode that the WAIT command
;  trapped. For example, if the user pressed Ctrl-Z, the dynamic array will
;  contain the following elements:
;    Dynarray EventInfo[]
;    EventInfo["TYPE"] = "KEY"
;    EventInfo["KEYCODE"] = 26

   SWITCH
      CASE (EventInfo["TYPE"] = "KEY") :

         ; The following SWITCH...CASE...ENDSWITCH statement performs a
         ; series of tests to determine what key was pressed and what mode
         ; Paradox was in when the key was pressed.
         SWITCH

            ; The following CASE executes when the user presses the
            ; Delete key (Keycode -83). This CASE calls the custom "Confirm
            ; Delete" dialog box before deleting the invoice.
            ; Because the delete is processed in the DisplayDeleteBox()
            ; procedure, we return 1 to go back to the WAIT, deny the
            ; pending event, and cancel the current trigger cycle.
            CASE (EventInfo["KEYCODE"] = -83) :     ; Del
               DisplayDeleteBox()
               RETURN 1

            ; The following CASE executes when the user presses the
            ; Do_It! F2 key. Each IF statement within this CASE tests
            ; to see what state Paradox was in when the F2 key was
            ; pressed, so the application can take the appropriate action.
            CASE (EventInfo["KEYCODE"] = -60) :    ; Do_It!

               ; It is possible that the user was in Field View, and
               ; chose F2 to get out of Field View, not out of the
               ; current wait.
               IF (ISFIELDVIEW() = True)
                  THEN RETURN 0
               ENDIF

               ; It's also possible the user was in LookupHelp, and
               ; pressed F2 to select a value from the lookup table.
               IF (HELPMODE() = "LookupHelp")
                  THEN RETURN 0
               ENDIF

               ; It's possible the user was in CoEdit mode. We can't
               ; leave CoEdit if the field data is invalid (e.g.
               ; invalid date or incomplete picture). Before we
               ; leave, we want to make sure that the value in
               ; the current field is valid.
               IF (ISVALID() <> True)
                  THEN RETURN 0
               ENDIF

               ; If the record passes the previous validity test,
               ; we execute a Do_It! to try to post the record.
               ; The following IF statement then evaluates the mode
               ; the system is in. If the system is in Main mode, the
               ; Do_It! was successful and we terminate the WAIT
               ; with a RETURN 2.
               Do_It!
               IF (SYSMODE() = "Main")
                  THEN RETURN 2  ; exit the WAIT
               ENDIF

               ; If the Do_It! does not put the system in Main mode
               ; and terminate the WAIT, a key violation exists. We then
               ; issue an ECHO NORMAL to display the desktop to the user,
               ; issue a Do_It! again so Paradox displays the KeyViol
               ; message to the user, and RETURN 1 to go back to the
               ; WAIT to let the user resolve the KeyViol.
               ECHO NORMAL
               Do_It!
               RETURN 1    ; couldn't leave CoEdit, let user resolve KeyViol

            ; The following CASE executes when the user presses the
            ; Ctrl-T Total key (Keycode 20). This CASE calls the proc
            ; that totals the order lines.
            CASE (EventInfo["KEYCODE"] = 20)  :       ; Ctrl-T End of Sale
               CalculateSaleTotal()
               RETURN 1

            ; The following CASE executes when the user presses
            ; Ctrl-O or Alt-O. This CASE denies the event so the user
            ; doesn't inadvertently shell to DOS.
            CASE (EventInfo["KEYCODE"] = 15) OR    ; Dos
                 (EventInfo["KEYCODE"] = -24) :    ; DosBig
               ; Stay within the wait but don't process any more
               ; events in the current cycle.
               RETURN 1

            OTHERWISE:
               SOUND 400 100   ; issue a beep in other situations
               RETURN 1

         ENDSWITCH

      ; If the EventInfo["MESSAGE"] element is "MENUSELECT", then the user
      ; has chosen from the menu.
      CASE (EventInfo["MESSAGE"] = "MENUSELECT") :

         ; The following SWITCH...CASE...ENDSWITCH statement performs a
         ; series of tests to determine what the user chose from the menu.
         SWITCH

            ; The following CASE executes when the user chooses |About.
            ; This CASE calls a proc to display a dialog box containing
            ; information about the application. It then returns 0 to
            ; go back to the WAIT.
            CASE (EventInfo["MENUTAG"] = "AltSpace/About") :
               DisplayAboutBox()
               RETURN 0

            ; The following CASE executes when the user chooses
            ; Table|Close. The IF statement tests to see if the user is
            ; in Field View (in the Shipping instructions memo) and closes
            ; the memo, if necessary.
            CASE (EventInfo["MENUTAG"] = "Table/Close") :
               IF (ISFIELDVIEW() = True) ; if the user is in Field View
                  THEN Do_It!            ; save the memo and close it
               ENDIF

               ; We execute a Do_It! to try to post the record.
               ; The following IF statement then evaluates the mode
               ; the system is in. If the system is in Main mode, the
               ; Do_It! was successful and we terminate the WAIT
               ; with a RETURN 2.
               Do_It!
               IF (SYSMODE() = "Main")
                  THEN RETURN 2  ; exit the WAIT
               ENDIF

               ; If the Do_It! does not put the system in Main mode
               ; and terminate the WAIT, a key violation exists. We then
               ; issue an ECHO NORMAL to display the desktop to the user,
               ; issue a Do_It! again so Paradox displays the KeyViol
               ; message to the user, and RETURN 1 to go back to the
               ; WAIT to let the user resolve the KeyViol.
               ECHO NORMAL
               Do_It!
               RETURN 1   ; couldn't leave CoEdit, let user resolve problem

            OTHERWISE:
               SOUND 400 100
               RETURN 1

         ENDSWITCH

      ; This is the proc's safety valve. If the wait sends a message
      ; we haven't planned on, then beep, process any further events
      ; in the cycle, and remain within the wait.
      OTHERWISE :
         SOUND 400 100
         RETURN 1    ; for safety, ignore events we don't recognize

   ENDSWITCH

ENDPROC



; --------------------------------------------------------------------------
; Procedure   : DisplayDeleteBox()
; Description :
;     Brings up a dialog box prompting the user to confirm that s/he
;     wants to Delete the record. If the user chooses Ok, then we
;     can go ahead and delete the user. If not, then just return.
; Called By   : ProcessWaitEvents()
; --------------------------------------------------------------------------

PROC DisplayDeleteBox()

   ; Define the "Delete" dialog box.
   SHOWDIALOG "Delete Item"
      @ 6, 10
      HEIGHT 7
      WIDTH 54

      ; Text within the box itself.
      @ 1, 4 ?? "Are you sure you want to delete this item?"

      PUSHBUTTON @ 3, 30 WIDTH 12
         "~C~ancel"
         CANCEL
         VALUE "CancelButton"
         TAG "Cancel"
      TO CancelButton

      ; Place the OK and CANCEL buttons.
      PUSHBUTTON @ 3, 11 WIDTH 12
         "~O~K"
         OK
         VALUE "OK"
         TAG "OKButton"
      TO OKButton

   ENDDIALOG

   ; If the user accepted the dialog, then we go ahead and delete
   ; this Item record. We then issue an ECHO NORMAL so the user
   ; can see Paradox display the Delete message.
   IF (RetVal = True)
      THEN ECHO NORMAL
           Del
   ENDIF

ENDPROC



; --------------------------------------------------------------------------
; Procedure  : CalculateSaleTotal()
; Description:
;     When the user presses Ctrl-T, the line items are extended and added
;     to the relevent Trans fields to create an Sale total.
; Called By  : ProcessWaitEvents()
; --------------------------------------------------------------------------

PROC CalculateSaleTotal()
PRIVATE LineTotal
   LineTotal = 0
    
   ; If we're not on the Trans table, then inform the user that Sale
   ; totalling can only occur from there.
   IF (TABLE() <> "Trans")
      THEN BEEP
           MESSAGE "You must be in the Trans table to calculate totals"
           SLEEP 2500     ; pause to display message
           MESSAGE ""     ; clear the message
           RETURN
   ENDIF
   
   ; we can subtotal the line items. Move to the Pos table.
   MOVETO "Pos"

   ; calculate the extended price for each item number sold

   SCAN
      IF ((ISBLANK([QTY SOLD]) = False) AND  ; only update totals for
          (ISBLANK([Item no]) = False))      ; records with qty and item
            THEN [DISC$] = (([PRICE] * [QTY SOLD])*[DISC%])
      ENDIF

      IF ((ISBLANK([QTY SOLD]) = False) AND  ; only update totals for
          (ISBLANK([Item No]) = False))      ; records with qty and item
            THEN [Amount] = ([PRICE] * [QTY SOLD])-[DISC$]
              LineTotal = (LineTotal + [Amount])
      ENDIF

   ENDSCAN

   ; Now we need to update the Trans totalling fields
   MOVETO "Trans"
   [Subtotal] = LineTotal                                 ; update subtotal

   IF (ISBLANK([Tax%]) = True)
      THEN [Tax%] = 0
   ENDIF

   [Tax$] = ([Subtotal] * [TAX%])                         ; Tax Amount

   [Total] =([Subtotal] +  [Tax])                         ; Sale Total

   IF (ISBLANK([CHANGE]) = True)
      THEN [CHANGE]= ([TOTAL]-[TENDER])
   ENDIF

ENDPROC



; --------------------------------------------------------------------------
; Procedure  : ShowSplashScreen
; Description:
;    Creates a window showing the application's "splash" screen.
;
; Called By  : Main()
; --------------------------------------------------------------------------

PROC ShowSplashScreen()

; define the display attributes of the splash screen window
   DYNARRAY WindowAttributes[]
   WindowAttributes["ORIGINROW"] = 7
   WindowAttributes["ORIGINCOL"] = 13
   WindowAttributes["WIDTH"] = 56
   WindowAttributes["HEIGHT"] = 11
   WindowAttributes["STYLE"] = 30           ; yellow on blue
   WindowAttributes["HASFRAME"] = False     ; creates a frameless window
   WindowAttributes["FLOATING"] = True      ; sets the window "above" the
                                            ; echo layer

; show the splash screen window
   WINDOW CREATE ATTRIBUTES WindowAttributes TO SplashWindow

; paint information inside the splash screen window
   @ 2,0 ?? FORMAT("W56,AC", "THE GREAT AMERICAN CRAFT SHOW.....")
   @ 4,0 ?? FORMAT("W56,AC", "Serving Artisans & Appreciators")
   @ 6,0 ?? FORMAT("W56,AC", "of Fine Arts & Crafts.")

   SLEEP 3500

   WINDOW CLOSE

ENDPROC



; The Main Event
; ----------------------------------
; The following line calls the Main() procedure. The Main() procedure
; starts the Sample application.
Main()

; Clean Up
; ----------------------------------
; We're done. Close any open images and release any variables and procedures
; before we exit.
RESET
RELEASE PROCS ALL
RELEASE VARS ALL
